package com.xinyilu.system.service.impl;

import com.xinyilu.common.annotation.DataScope;
import com.xinyilu.common.constant.UserConstants;
import com.xinyilu.common.core.domain.AjaxResult;
import com.xinyilu.common.core.domain.entity.SysRole;
import com.xinyilu.common.core.domain.entity.SysUser;
import com.xinyilu.common.exception.ServiceException;
import com.xinyilu.common.utils.DateUtils;
import com.xinyilu.common.utils.SecurityUtils;
import com.xinyilu.common.utils.StringUtils;
import com.xinyilu.common.utils.bean.BeanValidators;
import com.xinyilu.common.utils.spring.SpringUtils;
import com.xinyilu.system.domain.SysPost;
import com.xinyilu.system.domain.SysUserPost;
import com.xinyilu.system.domain.SysUserRole;
import com.xinyilu.system.domain.dto.SysUserDTO;
import com.xinyilu.system.domain.kindergarteninfo.KindergartenInfo;
import com.xinyilu.system.domain.sysuserclassrelation.SysUserClassRelation;
import com.xinyilu.system.domain.vo.ClassInfoVO;
import com.xinyilu.system.domain.vo.SysUserVO;
import com.xinyilu.system.domain.vo.UserVO;
import com.xinyilu.system.mapper.*;
import com.xinyilu.system.mapper.classinfo.ClassInfoMapper;
import com.xinyilu.system.mapper.kindergarteninfo.KindergartenInfoMapper;
import com.xinyilu.system.mapper.sysuserclassrelation.SysUserClassRelationMapper;
import com.xinyilu.system.service.ISysConfigService;
import com.xinyilu.system.service.ISysUserService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.util.CollectionUtils;

import javax.annotation.Resource;
import javax.validation.Validator;
import java.util.ArrayList;
import java.util.List;
import java.util.Objects;
import java.util.stream.Collectors;

/**
 * 用户 业务层处理
 *
 * @author xinyilu
 */
@Service
public class SysUserServiceImpl implements ISysUserService {
    private static final Logger log = LoggerFactory.getLogger(SysUserServiceImpl.class);

    @Resource
    private SysUserMapper userMapper;

    @Resource
    private SysRoleMapper roleMapper;

    @Resource
    private SysPostMapper postMapper;

    @Resource
    private SysUserRoleMapper userRoleMapper;

    @Resource
    private SysUserPostMapper userPostMapper;

    @Resource
    private ISysConfigService configService;

    @Resource
    protected Validator validator;

    @Resource
    private KindergartenInfoMapper kindergartenInfoMapper;

    @Resource
    private SysUserClassRelationMapper sysUserClassRelationMapper;

    /**
     * 根据条件分页查询用户列表
     *
     * @param user 用户信息
     * @return 用户信息集合信息
     */
    @Override
    @DataScope(deptAlias = "d", userAlias = "u")
    public List<SysUserVO> selectUserList(SysUser user) {
        return userMapper.selectUserList(user);
    }

    /**
     * 根据条件分页查询已分配用户角色列表
     *
     * @param user 用户信息
     * @return 用户信息集合信息
     */
    @Override
    @DataScope(deptAlias = "d", userAlias = "u")
    public List<SysUser> selectAllocatedList(SysUser user) {
        return userMapper.selectAllocatedList(user);
    }

    /**
     * 根据条件分页查询未分配用户角色列表
     *
     * @param user 用户信息
     * @return 用户信息集合信息
     */
    @Override
    @DataScope(deptAlias = "d", userAlias = "u")
    public List<SysUser> selectUnallocatedList(SysUser user) {
        return userMapper.selectUnallocatedList(user);
    }

    /**
     * 通过用户名查询用户
     *
     * @param userName 用户名
     * @return 用户对象信息
     */
    @Override
    public SysUser selectUserByUserName(String userName) {
        return userMapper.selectUserByUserName(userName);
    }

    /**
     * 通过用户ID查询用户
     *
     * @param userId 用户ID
     * @return 用户对象信息
     */
    @Override
    public SysUserVO selectUserById(Long userId) {
        SysUserVO sysUserVO = userMapper.selectUserById(userId);
        List<ClassInfoVO> sysUserClassInfoList = sysUserClassRelationMapper.getSysUserClassInfoList(userId);
        sysUserVO.setClassInfoList(sysUserClassInfoList);
        return sysUserVO;
    }

    /**
     * 查询用户所属角色组
     *
     * @param userName 用户名
     * @return 结果
     */
    @Override
    public String selectUserRoleGroup(String userName) {
        List<SysRole> list = roleMapper.selectRolesByUserName(userName);
        if (CollectionUtils.isEmpty(list)) {
            return StringUtils.EMPTY;
        }
        return list.stream().map(SysRole::getRoleName).collect(Collectors.joining(","));
    }

    /**
     * 查询用户所属岗位组
     *
     * @param userName 用户名
     * @return 结果
     */
    @Override
    public String selectUserPostGroup(String userName) {
        List<SysPost> list = postMapper.selectPostsByUserName(userName);
        if (CollectionUtils.isEmpty(list)) {
            return StringUtils.EMPTY;
        }
        return list.stream().map(SysPost::getPostName).collect(Collectors.joining(","));
    }

    /**
     * 校验用户名称是否唯一
     *
     * @param userName 用户名称
     * @return 结果
     */
    @Override
    public String checkUserNameUnique(String userName) {
        int count = userMapper.checkUserNameUnique(userName);
        if (count > 0) {
            return UserConstants.NOT_UNIQUE;
        }
        return UserConstants.UNIQUE;
    }

    /**
     * 校验手机号码是否唯一
     *
     * @param user 用户信息
     * @return
     */
    @Override
    public String checkPhoneUnique(SysUser user) {
        Long userId = StringUtils.isNull(user.getUserId()) ? -1L : user.getUserId();
        SysUser info = userMapper.checkPhoneUnique(user.getPhonenumber());
        if (StringUtils.isNotNull(info) && info.getUserId().longValue() != userId.longValue()) {
            return UserConstants.NOT_UNIQUE;
        }
        return UserConstants.UNIQUE;
    }

    /**
     * 校验email是否唯一
     *
     * @param user 用户信息
     * @return
     */
    @Override
    public String checkEmailUnique(SysUser user) {
        Long userId = StringUtils.isNull(user.getUserId()) ? -1L : user.getUserId();
        SysUser info = userMapper.checkEmailUnique(user.getEmail());
        if (StringUtils.isNotNull(info) && info.getUserId().longValue() != userId.longValue()) {
            return UserConstants.NOT_UNIQUE;
        }
        return UserConstants.UNIQUE;
    }

    /**
     * 校验用户是否允许操作
     *
     * @param user 用户信息
     */
    @Override
    public void checkUserAllowed(SysUser user) {
        if (StringUtils.isNotNull(user.getUserId()) && user.isAdmin()) {
            throw new ServiceException("不允许操作超级管理员用户");
        }
    }

    /**
     * 校验用户是否有数据权限
     *
     * @param userId 用户id
     */
    @Override
    public void checkUserDataScope(Long userId) {
        if (!SysUser.isAdmin(SecurityUtils.getUserId())) {
            SysUser user = new SysUser();
            user.setUserId(userId);
            List<SysUserVO> users = SpringUtils.getAopProxy(this).selectUserList(user);
            if (StringUtils.isEmpty(users)) {
                throw new ServiceException("没有权限访问用户数据！");
            }
        }
    }

    /**
     * 新增保存用户信息
     *
     * @param user 用户信息
     * @return 结果
     */
    @Override
    @Transactional(rollbackFor = Exception.class)
    public AjaxResult insertUser(SysUserDTO user) {
        // 新增用户信息
        int rows = userMapper.insertUser(user);
        // 新增用户岗位关联
        insertUserPost(user);
        // 新增用户与角色管理
        insertUserRole(user);
        if (org.apache.commons.collections4.CollectionUtils.isNotEmpty(user.getClassInfoList())) {
            List<SysUserClassRelation> sysUserClassRelationList = new ArrayList<>();
            user.getClassInfoList().forEach(sysUserClassId -> {
                SysUserClassRelation sysUserClass = new SysUserClassRelation();
                sysUserClass.setClassId(sysUserClassId);
                sysUserClass.setUserId(user.getUserId());
                sysUserClass.setDelFlag(0);
                sysUserClass.setUpdateBy(SecurityUtils.getUsername());
                sysUserClass.setUpdateTime(DateUtils.getNowDate());
                sysUserClassRelationList.add(sysUserClass);
            });
            int sysUserClassRelation = sysUserClassRelationMapper.insertSysUserClassRelationList(sysUserClassRelationList);
            if (sysUserClassRelation <= 0) {
                throw new ServiceException("新增班级信息失败!");
            }
        }
        // 修改幼儿园信息
        if (Objects.nonNull(user.getKindergartenId())) {
            updateKindergartenInfo(user.getUserId(), user.getKindergartenId(), null);
        }
        return AjaxResult.success(rows);
    }

    /**
     * 注册用户信息
     *
     * @param user 用户信息
     * @return 结果
     */
    @Override
    public boolean registerUser(SysUser user) {
        return userMapper.insertUser(user) > 0;
    }

    /**
     * 修改保存用户信息
     *
     * @param user 用户信息
     * @return 结果
     */
    @Override
    @Transactional(rollbackFor = Exception.class)
    public AjaxResult updateUser(SysUserDTO user) {
        Long userId = user.getUserId();
        // 修改幼儿园信息
        SysUserVO sysUserVO = userMapper.selectUserById(userId);
        if (Objects.nonNull(user.getKindergartenId())) {
            updateKindergartenInfo(userId, user.getKindergartenId(), sysUserVO.getKindergartenId());
        }
        // 删除用户与角色关联
        userRoleMapper.deleteUserRoleByUserId(userId);
        // 新增用户与角色管理
        insertUserRole(user);
        // 删除用户与岗位关联
        userPostMapper.deleteUserPostByUserId(userId);
        // 新增用户与岗位管理
        insertUserPost(user);
        //修改区域信息
        if (Objects.isNull(user.getAreaId())) {
            userMapper.updateUserArea(userId);
        }
        //根据userID查询数据库中的classId
        List<Long> classIdList = sysUserClassRelationMapper.getSysUserClassRelationList(userId).stream().filter(Objects::nonNull).filter(classId -> Objects.nonNull(classId.getClassId())).map(SysUserClassRelation::getClassId).collect(Collectors.toList());
        //传过来的
        List<Long> classInfoList = new ArrayList<>();
        //如果原先是老师 现在换成家长 班级id与幼儿园id传null
        if (org.apache.commons.collections4.CollectionUtils.isNotEmpty(user.getClassInfoList())) {
            classInfoList = user.getClassInfoList();
        }
        //数据库中的
        //传过来的与数据库中的做差集 要新增的
        List<Long> subtractClassIdList = new ArrayList<>(org.apache.commons.collections4.CollectionUtils.subtract(classInfoList, classIdList));
        //数据库中的与传过来的做差集 要删除的
        List<Long> sysUserClassIdList = new ArrayList<>(org.apache.commons.collections4.CollectionUtils.subtract(classIdList, classInfoList));
        //修改用户所属班级关系表 先增再删
        List<SysUserClassRelation> sysUserClassRelationList = new ArrayList<>();
        if (org.apache.commons.collections4.CollectionUtils.isNotEmpty(subtractClassIdList)) {
            subtractClassIdList.forEach(sysUserClassId -> {
                SysUserClassRelation sysUserClass = new SysUserClassRelation();
                sysUserClass.setClassId(sysUserClassId);
                sysUserClass.setUserId(user.getUserId());
                sysUserClass.setDelFlag(0);
                sysUserClass.setUpdateBy(SecurityUtils.getUsername());
                sysUserClass.setUpdateTime(DateUtils.getNowDate());
                sysUserClassRelationList.add(sysUserClass);
            });
        }
        if (org.apache.commons.collections4.CollectionUtils.isNotEmpty(sysUserClassRelationList)) {
            int sysUserClassRelation = sysUserClassRelationMapper.insertSysUserClassRelationList(sysUserClassRelationList);
            if (sysUserClassRelation <= 0) {
                throw new ServiceException("新增班级信息失败!");
            }
        }
        if (org.apache.commons.collections4.CollectionUtils.isNotEmpty(sysUserClassIdList)) {
            sysUserClassIdList.forEach(sysUserClassId -> {
                sysUserClassRelationMapper.deleteSysUserClassById(user.getUserId(), sysUserClassId);
            });
        }
        userMapper.updateUser(user);
        return AjaxResult.success();
    }

    /**
     * 修改幼儿园信息
     *
     * @param userId         用户id
     * @param kindergartenId 幼儿园id
     */
    private void updateKindergartenInfo(Long userId, Long kindergartenId, Long sysUserKindergartenId) {
        KindergartenInfo kindergartenInfo = kindergartenInfoMapper.selectKindergartenInfoById(kindergartenId);
        KindergartenInfo kindergarten = new KindergartenInfo();
        if (Objects.nonNull(kindergartenInfo) && !userId.equals(kindergartenInfo.getPrincipalId())) {
            kindergarten.setPrincipalId(userId);
            kindergarten.setId(kindergartenInfo.getId());
            kindergarten.setUpdateBy(SecurityUtils.getUsername());
            kindergarten.setUpdateTime(DateUtils.getNowDate());
            //修改传入幼儿园园长
            kindergartenInfoMapper.updateKindergartenInfoUserId(kindergarten);
            if (Objects.nonNull(kindergartenInfo.getPrincipalId())) {
                SysUser dataSysUser = userMapper.selectSysUser(kindergartenInfo.getPrincipalId());
                if (Objects.nonNull(dataSysUser) && Objects.nonNull(dataSysUser.getUserId())) {
                    SysUser sysUser = new SysUser();
                    sysUser.setKindergartenId(null);
                    sysUser.setUserId(dataSysUser.getUserId());
                    sysUser.setUpdateBy(SecurityUtils.getUsername());
                    sysUser.setUpdateTime(DateUtils.getNowDate());
                    //修改原幼儿园园长的幼儿园信息
                    userMapper.updateSysUserKindergartenId(sysUser);
                }
            }
        }
        //修改元幼儿园园长
        if (Objects.nonNull(sysUserKindergartenId) && !kindergartenId.equals(sysUserKindergartenId)) {
            KindergartenInfo oldKindergarten = kindergartenInfoMapper.selectKindergartenInfoById(sysUserKindergartenId);
            if (Objects.nonNull(oldKindergarten)) {
                kindergarten.setPrincipalId(null);
                kindergarten.setId(sysUserKindergartenId);
                kindergartenInfoMapper.updateKindergartenInfoUserId(kindergarten);
            }
        }
    }

    /**
     * 用户授权角色
     *
     * @param userId  用户ID
     * @param roleIds 角色组
     */
    @Override
    @Transactional
    public void insertUserAuth(Long userId, Long[] roleIds) {
        userRoleMapper.deleteUserRoleByUserId(userId);
        insertUserRole(userId, roleIds);
    }

    /**
     * 修改用户状态
     *
     * @param user 用户信息
     * @return 结果
     */
    @Override
    public int updateUserStatus(SysUser user) {
        return userMapper.updateUser(user);
    }

    /**
     * 修改用户基本信息
     *
     * @param user 用户信息
     * @return 结果
     */
    @Override
    public int updateUserProfile(SysUser user) {
        return userMapper.updateUser(user);
    }

    /**
     * 修改用户头像
     *
     * @param userName 用户名
     * @param avatar   头像地址
     * @return 结果
     */
    @Override
    public boolean updateUserAvatar(String userName, String avatar) {
        return userMapper.updateUserAvatar(userName, avatar) > 0;
    }

    /**
     * 重置用户密码
     *
     * @param user 用户信息
     * @return 结果
     */
    @Override
    public int resetPwd(SysUser user) {
        return userMapper.updateUser(user);
    }

    /**
     * 重置用户密码
     *
     * @param userName 用户名
     * @param password 密码
     * @return 结果
     */
    @Override
    public int resetUserPwd(String userName, String password) {
        return userMapper.resetUserPwd(userName, password);
    }

    /**
     * 新增用户角色信息
     *
     * @param user 用户对象
     */
    public void insertUserRole(SysUser user) {
        this.insertUserRole(user.getUserId(), user.getRoleIds());
    }

    /**
     * 新增用户岗位信息
     *
     * @param user 用户对象
     */
    public void insertUserPost(SysUser user) {
        Long[] posts = user.getPostIds();
        if (StringUtils.isNotEmpty(posts)) {
            // 新增用户与岗位管理
            List<SysUserPost> list = new ArrayList<SysUserPost>(posts.length);
            for (Long postId : posts) {
                SysUserPost up = new SysUserPost();
                up.setUserId(user.getUserId());
                up.setPostId(postId);
                list.add(up);
            }
            userPostMapper.batchUserPost(list);
        }
    }

    /**
     * 新增用户角色信息
     *
     * @param userId  用户ID
     * @param roleIds 角色组
     */
    public void insertUserRole(Long userId, Long[] roleIds) {
        if (StringUtils.isNotEmpty(roleIds)) {
            // 新增用户与角色管理
            List<SysUserRole> list = new ArrayList<SysUserRole>(roleIds.length);
            for (Long roleId : roleIds) {
                SysUserRole ur = new SysUserRole();
                ur.setUserId(userId);
                ur.setRoleId(roleId);
                list.add(ur);
            }
            userRoleMapper.batchUserRole(list);
        }
    }

    /**
     * 通过用户ID删除用户
     *
     * @param userId 用户ID
     * @return 结果
     */
    @Override
    @Transactional(rollbackFor = Exception.class)
    public int deleteUserById(Long userId) {
        // 删除用户与角色关联
        userRoleMapper.deleteUserRoleByUserId(userId);
        // 删除用户与岗位表
        userPostMapper.deleteUserPostByUserId(userId);
        sysUserClassRelationMapper.deleteSysUserClassRelationById(userId);
        return userMapper.deleteUserById(userId);
    }

    /**
     * 批量删除用户信息
     *
     * @param userIds 需要删除的用户ID
     * @return 结果
     */
    @Override
    @Transactional(rollbackFor = Exception.class)
    public int deleteUserByIds(Long[] userIds) {
        for (Long userId : userIds) {
            checkUserAllowed(new SysUser(userId));
            checkUserDataScope(userId);
        }
        // 删除用户与角色关联
        userRoleMapper.deleteUserRole(userIds);
        // 删除用户与岗位关联
        userPostMapper.deleteUserPost(userIds);
        sysUserClassRelationMapper.deleteSysUserClassRelationByIds(userIds);
        return userMapper.deleteUserByIds(userIds);
    }

    /**
     * 导入用户数据
     *
     * @param userList        用户数据列表
     * @param isUpdateSupport 是否更新支持，如果已存在，则进行更新数据
     * @param operName        操作用户
     * @return 结果
     */
    @Override
    public String importUser(List<SysUserDTO> userList, Boolean isUpdateSupport, String operName) {
        if (StringUtils.isNull(userList) || userList.size() == 0) {
            throw new ServiceException("导入用户数据不能为空！");
        }
        int successNum = 0;
        int failureNum = 0;
        StringBuilder successMsg = new StringBuilder();
        StringBuilder failureMsg = new StringBuilder();
        String password = configService.selectConfigByKey("sys.user.initPassword");
        for (SysUserDTO user : userList) {
            try {
                // 验证是否存在这个用户
                SysUser u = userMapper.selectUserByUserName(user.getUserName());
                if (StringUtils.isNull(u)) {
                    BeanValidators.validateWithException(validator, user);
                    user.setPassword(SecurityUtils.encryptPassword(password));
                    user.setCreateBy(operName);
                    this.insertUser(user);
                    successNum++;
                    successMsg.append("<br/>" + successNum + "、账号 " + user.getUserName() + " 导入成功");
                } else if (isUpdateSupport) {
                    BeanValidators.validateWithException(validator, user);
                    user.setUpdateBy(operName);
                    this.updateUser(user);
                    successNum++;
                    successMsg.append("<br/>" + successNum + "、账号 " + user.getUserName() + " 更新成功");
                } else {
                    failureNum++;
                    failureMsg.append("<br/>" + failureNum + "、账号 " + user.getUserName() + " 已存在");
                }
            } catch (Exception e) {
                failureNum++;
                String msg = "<br/>" + failureNum + "、账号 " + user.getUserName() + " 导入失败：";
                failureMsg.append(msg + e.getMessage());
                log.error(msg, e);
            }
        }
        if (failureNum > 0) {
            failureMsg.insert(0, "很抱歉，导入失败！共 " + failureNum + " 条数据格式不正确，错误如下：");
            throw new ServiceException(failureMsg.toString());
        } else {
            successMsg.insert(0, "恭喜您，数据已全部导入成功！共 " + successNum + " 条，数据如下：");
        }
        return successMsg.toString();
    }

    /**
     * 根据权限角色标识获取对应得角色用户信息
     *
     * @param roleKey 权限标识
     * @return 用户信息集合
     */
    @Override
    public List<UserVO> getUserInfoByRoleKey(String roleKey) {
        return userMapper.getUserInfoByRoleKey(roleKey);
    }
}
